<template lang="pug">
.vc-input-file.input(:class="classes" @click.capture.stop="onClick")
	.vc-input-file__prepend-icon
		.vc-input-file__prepend-icon-loader(v-if="loading")
		b-icon(v-else :icon="prependIcon")
	.vc-input-file__name(v-if="filename") {{filename}}
	.vc-input-file__name.vc-input-file__name--placeholder(v-else) {{placeholder === null ? 'Escolha um arquivo' : placeholder}}
	.vc-input-file__remove(v-if="removable")
		b-icon(:icon="appendIcon" custom-size="is-custom")

	input.vc-input-file__input(ref="inputFile" type="file" @change="onChange")
</template>
<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import getValue from 'get-value';

/**
 * File input element
 */
@Component({
	props: {
		value: [String, File],
		disabled: Boolean,
		loading: Boolean,
		removable: { type: Boolean, default: true },
		placeholder: { type: String, default: null },
	},
})
export default class VcInputFile extends Vue {
	value!: string | File;
	disabled!: boolean;
	loading!: boolean;
	removable!: boolean;
	placeholder!: string;
	$refs!: any;

	/**
	 * Compatibility with b-field
	 */
	get parentField(): any {
		let parent = this.$parent;
		for (let i = 0; i < 3; i++) {
			if (parent && !parent.$data._isField) {
				parent = parent.$parent;
			}
		}
		return parent;
	}
	get statusType() {
		if (!this.parentField) return;
		if (!this.parentField.newType) return;
		if (typeof this.parentField.newType === 'string') {
			return this.parentField.newType;
		} else {
			for (let key in this.parentField.newType) {
				if (this.parentField.newType[key]) {
					return key;
				}
			}
		}
	}

	// Check if input is disabled
	get isInputDisabled() {
		return this.disabled || this.loading;
	}

	// Icon
	get prependIcon() {
		const iconDisabled = getValue(this, ['$vueComponentOptions', 'inputFileIconDisabled']) || 'file-lock';
		const iconDefault = getValue(this, ['$vueComponentOptions', 'inputFileIconDefault']) || 'file';
		return this.disabled ? iconDisabled : iconDefault;
	}

	// Icon to append
	get appendIcon() {
		const iconRemove = getValue(this, ['$vueComponentOptions', 'inputFileIconRemove']) || 'close';
		return this.value ? iconRemove : '';
	}

	// Classes for the root element
	get classes() {
		return [
			{
				'vc-input-file--value': !!this.value,
				'vc-input-file--loading': !!this.loading,
				'vc-input-file--disabled': !!this.disabled,
			},
			this.statusType,
		];
	}

	// Filename to show on the label
	get filename() {
		if (!this.value) return null;
		if (typeof this.value === 'string') return this.value;
		return this.value.name;
	}

	// On click event
	onClick(evt) {
		if (this.isInputDisabled) return;
		if (this.isRemoveElement(evt.target)) {
			this.$emit('input', null);
			return;
		}
		this.$refs.inputFile.value = '';
		this.$refs.inputFile.click();
	}

	// When the file has changed
	onChange(evt) {
		if (this.$refs.inputFile.files[0]) this.$emit('input', this.$refs.inputFile.files[0]);
	}

	// Check if element is to be revoved
	isRemoveElement(element) {
		let current = element;
		while (current !== null) {
			if (current.classList) {
				if (current.classList.contains('vc-input-file__remove')) return true;
				if (current.classList.contains('vc-input-file')) break;
			}
			current = current.parentNode;
		}
		return false;
	}
}
</script>
<style lang="scss" scoped>
@import '~bulma/sass/utilities/mixins.sass';

.vc-input-file {
	display: flex;
	align-items: center;
	padding: 0;

	cursor: pointer;

	// Prepend the icon
	.vc-input-file__prepend-icon {
		position: relative;
		border-right: 1px solid #ccc;
		padding: 0.25rem 0.5rem;
		height: 100%;
		width: 2.5rem;
		.vc-input-file__prepend-icon-loader {
			@include loader;
			margin: 0.25rem auto 0;
		}
	}

	// Filename
	.vc-input-file__name {
		padding: 0.25rem 0.5rem;
		flex: 1 1 auto;
		&.vc-input-file__name--placeholder {
			color: #666;
			user-select: none;
		}
	}

	// File input element
	.vc-input-file__input {
		visibility: hidden;
		position: absolute;
		pointer-events: none;
	}

	// Wrapper for remove icon
	.vc-input-file__remove {
		font-size: 1.25rem;
		display: inline-block;
		text-align: center;
		margin-right: 0.5rem;
		transition: color 0.15s;

		&:hover {
			color: #822;
		}
	}

	// Status
	&.vc-input-file--loading {
		cursor: wait;
	}
	&.vc-input-file--disabled {
		cursor: not-allowed;
		.vc-input-file__name {
			background-color: rgba(0, 0, 0, 0.075);
		}
	}
}
</style>

